﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace RemindersAndCommands.Commands
{
    public class ReminderCommand : ICommand
    {
        public event EventHandler CanExecuteChanged;

        public bool CanExecute(object parameter)
        {
            return !(Application.Current as App).featureReminder.IsTrialExpired;
        }

        public void Execute(object parameter)
        {
            (Application.Current as App).featureReminder.UsageCount++;
            (Application.Current as App).featureReminder.Notify();

            if ((Application.Current as App).featureReminder.IsTrialExpired == true)
            {
                this.RaiseCanExecuteChanged();
            }
        }

        public void RaiseCanExecuteChanged()
        {
            this.OnCanExecuteChanged(EventArgs.Empty);
        }

        protected virtual void OnCanExecuteChanged(EventArgs e)
        {
            if (CanExecuteChanged != null)
            {
                CanExecuteChanged(this, e);
            }
        }
    }
}
